Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents picCanvas As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.picCanvas = New System.Windows.Forms.PictureBox
        Me.SuspendLayout()
        '
        'picCanvas
        '
        Me.picCanvas.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.picCanvas.Dock = System.Windows.Forms.DockStyle.Fill
        Me.picCanvas.Location = New System.Drawing.Point(0, 0)
        Me.picCanvas.Name = "picCanvas"
        Me.picCanvas.Size = New System.Drawing.Size(292, 273)
        Me.picCanvas.TabIndex = 0
        Me.picCanvas.TabStop = False
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Controls.Add(Me.picCanvas)
        Me.Name = "Form1"
        Me.Text = "DrawBezier"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' The endpoints are points 0 and 3. 
    ' The interior control points are points 1 and 2.
    Private m_Pts(3) As PointF

    ' The index of the next point to define.
    Private m_NextPoint As Integer = 0

    ' Select a point.
    Private Sub picCanvas_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picCanvas.MouseDown
        ' If we're starting a new set of four points,
        ' get the first point.
        If m_NextPoint > 3 Then m_NextPoint = 0

        ' Save this point.
        m_Pts(m_NextPoint).X = e.X
        m_Pts(m_NextPoint).Y = e.Y

        ' Move to the next point.
        m_NextPoint = m_NextPoint + 1

        ' Redraw.
        picCanvas.Invalidate()
    End Sub

    ' Draw the currently selected points. 
    ' If we have four points, draw the Bezier curve.
    Private Sub picCanvas_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picCanvas.Paint
        e.Graphics.Clear(Me.BackColor)
        If m_NextPoint >= 4 Then
            ' Draw a spline the easy way.
            Dim thick_pen As New Pen(Color.White, 5)
            e.Graphics.DrawBezier(thick_pen, m_Pts(0), m_Pts(1), m_Pts(2), m_Pts(3))
            thick_pen.Dispose()

            ' Draw a spline the hard way.
            BezierStuff.DrawBezier(e.Graphics, Pens.Black, 0.01, _
                m_Pts(0), m_Pts(1), m_Pts(2), m_Pts(3))
        End If

        ' Draw the control points.
        For i As Integer = 0 To m_NextPoint - 1
            e.Graphics.FillRectangle(Brushes.White, m_Pts(i).X - 3, m_Pts(i).Y - 3, 6, 6)
            e.Graphics.DrawRectangle(Pens.Black, m_Pts(i).X - 3, m_Pts(i).Y - 3, 6, 6)
        Next i
    End Sub
End Class
